# 2.0.0
## Warning: this is a major change and now depends on Puppet 6.x+!

* This now completely drops support for Puppet versions 5 and below.
    * The weird node_encrypted_file type was totally removed.
    * The only supported encryption is now the deferred function.
    * The `node_encrypt::file` defined type was retained for backwards code
      compatibility, so you may not need to make code changes. It's now just a
      wrapper for the deferred function and will scream at you when you use it.


# 1.0.0

* Alex Fisher added some basic support for testing under OnceOver #70
* Some minor cleanups required to get the Approved badge on the Forge #77
* Alex Fisher fixed the ability to redact default resource attributes #75
* Language cleanup #76

# 0.4.1

* Allow node_encrypt::secret to accept Sensitive[String] values (@danielparks)


# 0.4.0
## Warning: this is a major change in functionality!

* Puppet 6 compatibility
* Added new Deferred function, meaning far far simpler and more universal usage
* Changed encryting certificate module to always use the hostcert
* Changed the target certificate model to look for the first of:
    1. client cert generated by the CA
    1. client cert synced by `node_encrypt::certificates`
    1. client cert sent by agent as custom fact.
* Which means, that we have a new custom fact, and (test this before relying on it)
  you probably don't need the `node_encrypt::certificates` class anymore. For safer
  upgrades, we'll default to the known good paths for now, but I'll change the order
  soon and make the fact the default.
* Upgrade path:
    * The simplest upgrade is to just upgrade the module and do nothing. It should
      continue to work the same for now.
    * If you're on Puppet 6, the better upgrade path would be to look at the new
      usage examples and start porting your code. It's far simpler and more universal.
      You can encrypt any parameter of any type, not just files.
    * Try removing the `node_encrypt::certificates` class and validate that nothing
      breaks in your infrastructure.


# 0.3.3

* Add CA server override parameter for cases in which the CA isn't autodetected properly


# 0.3.2

* Support managing binary files without spurious change notifications.
* Simplify public cert syncing to make it more reliable, especially with external CA
    * **NOTE**: The `certificates` class will now sync to all classified nodes.

# 0.3.1

* Just a hotpatch fix to resolve a compatibility issue with the Puppet Enterprise module.
* Please install this update if you're having trouble with `puppet node deactivate` or the like.

# 0.3.0

* Certificate distribution works on Puppet 5
* Added new ways to pass data to encrypt on the CLI
* Fixed the Ruby load path issue on OSS installs (@olifre)
* Fixed OpenSSL compatiblility with Ruby 2.4 (@olifre)

# 0.2.7

* Allow the `redact()` function to work with defined types. (@ross-w)

# 0.2.6

* Correctly handle namespace capitalization (@JeremyEinfeld)
* Use $path parameter properly
* Corrected some spec tests
* Warn when signature verification fails

# 0.2.5

* Added a `redact()` function to remove class parameters from the catalog.

# 0.2.4

* Reimplements `autobefore` on masters that don't support it. This corrects
  incompatibilities with 3.x masters.

# 0.2.3

* Adds command-line decrypt tool. This can be used in scripts or in `exec`
  resources.

# 0.2.2

* Synchronize certificates in a more robust way. The CA node will encrypt
  using certificates in the CA store so that no setup is required, but compile
  masters will encrypt using their own host certificate and synchronized agent
  certificates. This requires classification with `node_encrypt::certificates`.
* Simpler and more robust role detection. Works in standalone and in MoM setups.
* Use the CA verify chain on the agent.
* Stop playing with strings and just use the built-in `Puppet.settings`.

# 0.2.1

* Working around a *possibly* broken fqdn is probably just a real bad idea.
  This simplifies the CA node identification logic and removes the poorly
  thought out `ca_node` parameter that lasted for less than 24 hours.

# 0.2.0

* Allow this to work on nodes that are not the CA. (Requires some setup.)

# 0.1.2

* Erm. Actually include the bit that removes the content from the catalog.
* Added an `autobefore` to ensure this always lets a file resource correct
  out of sync parameters, if one is declared.

# 0.1.1

* Validate that plaintext is not passed to node_encrypted_file.
* Add ability to pass pre-encrypted ciphertext to node_encrypt::file.
* More docs and better specs.

#0.1.0

* Initial release.
